/* main.cpp */
#include <fstream>
#include <cassert>
#include <cmath>
#include <complex>
#include <cstdlib>
#include <iostream>
#include <map>
#include <string>
#include <utility>
#include <vector>
#include <stdio.h>
#include <time.h>
#include <iomanip>
#include <limits>

#include <string>
#include <ctime>

#include "inc/I.h"
#include "inc/PI.h"
#include "inc/newrand.h"
#include "inc/NDarray.h"
#include "inc/NDgrid.h"
#include "inc/iFunc.h"
#include "inc/Generator.h"
#include "inc/Particle.h"
#include "inc/Constants.h"
#include "inc/Kinematics.h"
#include "inc/Event.h"
#include "inc/Interface.h"

using namespace ExDiff;

int main(int argc, const char** argv){
	   
 
// final construction
// datacard is the argument of the main file (filename)

   const char* datacard = argv[1]; 

// reading input data card
// create interface   
   Interface iogen(datacard);
   iogen.GeneratorInfo();
   iogen.PrintPars();
      
// output using interface     
   iogen.GenerateFile();


// Analizer 1 ============================================
/*
// time variables ////////////////////////////////////////
    std::clock_t start;
    double durationm;
/////////////////////////////////////////////////////////
// time for calculations start	//////////////////////////												
			  printf("analizer clock start = %d\n", std::clock());
			  start = std::clock();
/////////////////////////////////////////////////////////

    Event ev;
    std::string filename="output/A1M2E0_2F0.exdiff";
    std::string ofilename="output/t_A1M2E0_2F0.res1";


   int i,j,n,Nbins;
   Nbins = 128; // number of bins in t variable
// t-bins 
    std::vector<double> tbin, result, tgrid;
    tbin.clear();    
    tgrid.clear();
    double taux=0.0;
    for(i = 0; i < Nbins; i++){
        taux=(2.0*i+1.0)*0.5/Nbins; 
        tbin.push_back(taux);
        taux=i*1.0/Nbins;
        tgrid.push_back(taux); 
        result.push_back(0.0);
// std::cout<< "tgrid " << tgrid[i] << " tbin " << tbin[i] <<std::endl;		        
    }

    std::cout<< "Begin to read events" <<std::endl;
// events reading and analysis

    int format = 0;
    double t;
    double x = 0.0;
    std::vector<int> Nfile = ev.TakeFromFile(10,format,filename);
    int Nevents = Nfile[1];

    std::cout<< "Number of events = " << Nevents << " Number of particles = " << Nfile[0] 
    << " Number of strings = " << Nfile[2] <<std::endl;

    for(n = 1; n < Nevents + 1; n++){
// read the n-th event from file
	ev.TakeEvent(Nfile,n,format,filename); 
// calculation of the variable t
        t = 0.0;  
        x = (ev._particles()[0]._E()-ev._particles()[2]._E());
        t = -x*x;
        x = (ev._particles()[0]._px()-ev._particles()[2]._px());
        t = t+x*x;
        x = (ev._particles()[0]._py()-ev._particles()[2]._py());
        t = t+x*x;
        x = (ev._particles()[0]._pz()-ev._particles()[2]._pz());
        t = t+x*x; 
        
// compare t with bins and put to the resulting array
//        j=0;
//        for(i = 0; i < Nbins; i++){
//          if(t >= tgrid[i] && t < tgrid[i+1]){
//             result[i]++;
//             j=i; 
//           }  	        
//         } 

        i = 0;
        j = 0;
        while(tgrid[i] <= t && i < Nbins){
          j=i;
          i++;
        }
        result[j]++;

        printf("n = %5i , |t| = %.6f, bin = %3i\n", n, t, j); 

      }

// output

    std::ofstream f;
		
    f.open(ofilename, std::ofstream::out | std::ofstream::app);

    if (!f.is_open()) {
      std::cout << "Can not add to an *.res file!\n";   
    } 

    for(i = 0; i < Nbins; i++){ 
     result[i]=result[i]/Nevents;
     f << std::setw(9) << "{ " << std::setprecision(19) 
        << std::scientific << tbin[i] << ", " 
         << std::scientific << result[i] << " }, \n"; 
    }  


 //   << std::endl;
  
  
    f.close();

// time for calculations stop	//////////////////////////
	    printf("clock stop = %d\n", std::clock());
            durationm = ( std::clock() - start ) / (double) CLOCKS_PER_SEC;
            std::cout<<"duration of the analizer = "<< durationm << '\n';
/////////////////////////////////////////////////////////
*/


// Analizer 2 HISTOGRAMS =================================
/*
// time variables ////////////////////////////////////////
    std::clock_t start;
    double durationm;
/////////////////////////////////////////////////////////
// time for calculations start	//////////////////////////												
			  printf("analizer 2 clock start = %d\n", std::clock());
			  start = std::clock();
/////////////////////////////////////////////////////////

    Event ev;
    std::string filename="output/A1M2E0_2F0.exdiff";
    std::string ofilename="output/t_A1M2E0_2F0.res2";


   int i,j,n,Nbins;
   Nbins = 128; // number of bins in t variable
// t-bins 
    std::vector<double> tbin, result, tgrid;
    tbin.clear();    
    tgrid.clear();
    double taux=0.0;
    for(i = 0; i < Nbins; i++){
        taux=(2.0*i+1.0)*0.5/Nbins; 
        tbin.push_back(taux);
        taux=i*1.0/Nbins;
        tgrid.push_back(taux); 
        result.push_back(0.0);
// std::cout<< "tgrid " << tgrid[i] << " tbin " << tbin[i] <<std::endl;		        
    }

    std::cout<< "Begin to read events" <<std::endl;
// events reading and analysis

    int format = 0;
    double t;
    double x = 0.0;
    std::vector<int> Nfile = ev.TakeFromFile(10,format,filename);
    int Nevents = Nfile[1];

    std::cout<< "Number of events = " << Nevents << " Number of particles = " << Nfile[0] 
    << " Number of strings = " << Nfile[2] <<std::endl;

    std::ofstream f;
		
    f.open(ofilename, std::ofstream::out | std::ofstream::app);

    if (!f.is_open()) {
      std::cout << "Can not add to an *.res file!\n";   
    } 


    for(n = 1; n < Nevents + 1; n++){
// read the n-th event from file
	ev.TakeEvent(Nfile,n,format,filename); 
// calculation of the variable t
        t = 0.0;  
        x = (ev._particles()[0]._E()-ev._particles()[2]._E());
        t = -x*x;
        x = (ev._particles()[0]._px()-ev._particles()[2]._px());
        t = t+x*x;
        x = (ev._particles()[0]._py()-ev._particles()[2]._py());
        t = t+x*x;
        x = (ev._particles()[0]._pz()-ev._particles()[2]._pz());
        t = t+x*x; 
// output        
        f << std::setw(9) << std::setprecision(6) 
        << std::scientific << t << "," << "\n"; 

      }

 //   << std::endl;
  
  
    f.close();

// time for calculations stop	//////////////////////////
	    printf("clock stop = %d\n", std::clock());
            durationm = ( std::clock() - start ) / (double) CLOCKS_PER_SEC;
            std::cout<<"duration of the analizer 2 = "<< durationm << '\n';
/////////////////////////////////////////////////////////
*/



return 0;

}
