/*
 * Event.cpp
 *
 *  Created on: 17 NOV 2016
 *      Author: Roman Ryutin
 */

#include <cmath>
#include <complex>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <map>
#include <string>
#include <utility>
#include <vector>
#include <stdio.h>
#include <cassert>
//////////////////////////
#include <iomanip>
#include <limits>

#include "../inc/I.h"
#include "../inc/PI.h"
#include "../inc/Particle.h"
#include "../inc/Constants.h"
#include "../inc/Event.h"

// functions of class Event ===========================================

// print
void ExDiff::Event::Print(int format){
   if(format == 0){	
	 std::cout<< " ============================================= " <<std::endl;
	 int i = 0;
	 for(i = 0; i < 2; i++){
	   printf("p_initial[ %1i ] = { %.6f , %.6f , %.6f , %.6f }, mass = %.6f, ID = %4i, 2*Spin+1 = %2i, C (AntiC) = %1i (%1i), onShell = %1i \n", i+1, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3], particles[i]._m(), particles[i]._ID(), particles[i]._DSpin(), particles[i]._Colour(), particles[i]._Anticolour(), particles[i].OnShell());	
     }
	 for(i = 2; i < particles.size(); i++){
	   printf("p_final[ %1i ] = { %.6f , %.6f , %.6f , %.6f }, mass = %.6f, ID = %4i, 2*Spin+1 = %2i, C (AntiC) = %1i (%1i), onShell = %1i  \n", i-1, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3], particles[i]._m(), particles[i]._ID(), particles[i]._DSpin(), particles[i]._Colour(), particles[i]._Anticolour(), particles[i].OnShell());	
     }	
	 std::cout<< " ============================================= " <<std::endl;
   }

   if(format == 1){	
	 std::cout<< " ============================================= " <<std::endl;
	 int i = 0;
	 for(i = 0; i < 2; i++){
	   printf("p_initial[ %1i ] = { %.6f , %.6f , %.6f , %.6f }, mass = %.6f, onShell = %1i \n", i+1, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3], particles[i]._m(), particles[i].OnShell());	
     }
	 for(i = 2; i < particles.size(); i++){
	   printf("p_final[ %1i ] = { %.6f , %.6f , %.6f , %.6f }, mass = %.6f, onShell = %1i  \n", i-1, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3], particles[i]._m(), particles[i].OnShell());	
     }	
	 std::cout<< " ============================================= " <<std::endl;
   }

   if(format == 2){	
	 std::cout<< " ============================================= " <<std::endl;
	 int i = 0;
	 for(i = 0; i < 2; i++){
	   printf("p_initial[ %1i ] = { %.6f , %.6f , %.6f , %.6f }\n", i+1, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3]);	
     }
	 for(i = 2; i < particles.size(); i++){
	   printf("p_final[ %1i ] = { %.6f , %.6f , %.6f , %.6f }\n", i-1, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3]);	
     }	
	 std::cout<< " ============================================= " <<std::endl;
   }

   if(format == 3){	
	 std::cout<< " ============================================= " <<std::endl;
	 int i = 0;
	 for(i = 2; i < particles.size(); i++){
	   printf("p_final[ %1i ] = { %.6f , %.6f , %.6f , %.6f }\n", i-1, particles[i]._p()[0], particles[i]._p()[1], particles[i]._p()[2], particles[i]._p()[3]);	
     }	
	 std::cout<< " ============================================= " <<std::endl;
   }
   printf("CheckSum = %1i\n", CheckSum());
   return;
   
};
// output to file
void ExDiff::Event::AddToFile(int format_, std::string filename_){
 
 std::ofstream f;
 int i = 0;
		
 f.open(filename_, std::ofstream::out | std::ofstream::app);
 if (!f.is_open()) {
   std::cout << "Can not add to an *.exdiff file!\n";   
 }	 
 
 
 if(format_ == 0){	 

//   std::cout << "write to file !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  " << filename_ << std::endl; 
   f << "================================================= ExDiff Event ============================================================" << std::endl;
   f << "---------------------------------------------------------------------------------------------------------------------------" << std::endl;
   f << "      ID                E                           px                         py                           pz" << std::endl;
   f << "---------------------------------------------------------------------------------------------------------------------------" << std::endl;  
   
  for(i = 0; i < 2; i++){ 
   f << std::setw(9) << particles[i]._ID() << std::setprecision(19) << std::setw(34)
      << std::scientific << particles[i]._p()[0] << std::setw(34)
      << std::scientific << particles[i]._p()[1] << std::setw(34)
	  << std::scientific << particles[i]._p()[2] << std::setw(34)
	  << std::scientific << particles[i]._p()[3] << std::endl; 
  }   

  f << "---------------------------------------------------------------------------------------------------------------------------" << std::endl;

  for(i = 2; i < particles.size(); i++)
   f << std::setw(9) << particles[i]._ID() << std::setprecision(19) << std::setw(34)
      << std::scientific << particles[i]._p()[0] << std::setw(34)
      << std::scientific << particles[i]._p()[1] << std::setw(34)
	  << std::scientific << particles[i]._p()[2] << std::setw(34)
	  << std::scientific << particles[i]._p()[3] << std::endl;  	 
  
  f << "===========================================================================================================================" << std::endl;
 }  

 f.close();	     
 
 return; 
    
}; 
// take from file
std::vector<int> ExDiff::Event::TakeFromFile(int number_, int format_, std::string filename_){
        std::ifstream f; 

		ExDiff::Constants c;
        int Npart = 0;
        int Nev = 0;
        int Nstr = 0;
        std::vector<int> Nresult;
        Nresult.clear(); 
		int id = 0;
		int dspin = 1;
		int col = 0;
		int acol = 0;
		double mass = 0.0;
		std::vector<double> v = {0.0,0.0,0.0,0.0};
		std::vector<double> E, px, py, pz;
		std::vector<int> ids;
		char str[255];
		char r;
		int i = 0;
		int n = 0;
		
		E.clear();
		px.clear();
		py.clear();
		pz.clear();
		ids.clear();
// define number of particles
//format 0
   if(format_ == 0){ 
	  
        f.open(filename_, std::ifstream::in);
        if (!f.is_open()) {
          std::cout << "Can not open a *.exdiff file!\n";   
		}		
		
		std::ios::pos_type pos = f.tellg();
		
		for(i = 0; i < 11; i++){ 
		  f >> str;
//		  std::cout << str << "\n"; 
		}
       	for(i = 0; i < 2; i++){	
		  f >> id >> v[0] >> v[1] >> v[2] >> v[3];
//		  printf(" %6i %.6f %.6f %.6f %.6f\n", id, v[0], v[1], v[2], v[3]);
		  ids.push_back(id);
		  E.push_back(v[0]);
		  px.push_back(v[1]);
		  py.push_back(v[2]);
		  pz.push_back(v[3]);
		  Npart += 1;
        }
		
		f >> str;
//		std::cout << str << "\n";
	
        while (n == 0)// symbol =
         {
		  f >> id >> v[0] >> v[1] >> v[2] >> v[3];
//		  printf(" %6i %.6f %.6f %.6f %.6f\n", id, v[0], v[1], v[2], v[3]);
		  ids.push_back(id);
		  E.push_back(v[0]);
		  px.push_back(v[1]);
		  py.push_back(v[2]);
		  pz.push_back(v[3]);
		  Npart += 1;	
// save current position
          pos = f.tellg();
		  
          f >> str;
//		  std::cout << str << "\n";
		  r = str[0];
		  if(r == '='){
			  n=1;
		  } else{
             f.seekg(pos);		  
		  }
//          printf("n = %1i \n", n);
         }
		 
       f.close();
	   
//	   printf("Number of final particles = %1i\n", Npart-2);
// reading event
	   ExDiff::Particle pa;
       f.open(filename_, std::ifstream::in);	   
	   
/////////////////
        n = 1;
               
//        while(n < number_ + 1 && !f.eof()){
          while(!f.eof()){

// format 0		
    	  for(i = 0; i < 11; i++){ 
		    f >> str;
		  }
       	  for(i = 0; i < 2; i++){	
		    f >> ids[i] >> E[i] >> px[i] >> py[i] >> pz[i];
          }	
		  f >> str;	
          for (i = 2; i < E.size(); i++){			
		    f >> ids[i] >> E[i] >> px[i] >> py[i] >> pz[i];
		   }   
          f >> str;
          
	  if(n == number_){
			// set particles
			particles.clear();
            for(i = 0; i < E.size(); i++){
			  pa.Reset({E[i],px[i],py[i],pz[i]},c._mass(ids[i]),ids[i],c._dspin(ids[i]),0,0);	
//			  pa.Print();
			  particles.push_back(pa);	
			}				
	   }
		  
		  n += 1;
		  		  
        } 
		 
       f.close();
       Nev = n - 2; 
       Nstr = (Npart+6)*Nev;
       Nresult.push_back(Npart);
       Nresult.push_back(Nev);
       Nresult.push_back(Nstr);

   }   
	
	   if(n < number_){
		  std::cout << "There are " << n-2 <<  " events only! Not enough events to get " << number_ << "'s event" << "\n"; 
	   }
	   
       return Nresult;				
 
};

// take event
void ExDiff::Event::TakeEvent(std::vector<int> Nfile_, int number_, int format_, std::string filename_){
        std::ifstream f; 

		ExDiff::Constants c;
        int Npart = Nfile_[0];
        int Nev = Nfile_[1];
        int Nstr = Nfile_[2];
        
		int id = 0;
		int dspin = 1;
		int col = 0;
		int acol = 0;
		double mass = 0.0;
		std::vector<double> v = {0.0,0.0,0.0,0.0};
		std::vector<double> E, px, py, pz;
		std::vector<int> ids;

		char str[255];
		char r;
		int i = 0;
                int npos = (13+Npart*5)*(number_-1);
		
		E.clear();
		px.clear();
		py.clear();
		pz.clear();
		ids.clear();

                for (i = 0; i < Npart; i++){			
		    ids.push_back(0);
                    E.push_back(0.0);
                    px.push_back(0.0);
                    py.push_back(0.0);
                    pz.push_back(0.0);
		   }   

                ExDiff::Particle pa;
// number of the event <= Number of events in the file
 if(number_ <= Nev){

//format 0
     if(format_ == 0){ 
	  				
// reading event

       f.open(filename_, std::ifstream::in);	
       if (!f.is_open()) {
          std::cout << "Can not open a *.exdiff file!\n";   
       }   

// set position to the pos, which corresponds to number_'s event, number_=1,2,3,...,Nev		
	std::ios::pos_type pos = f.tellg(); 
//        pos = pos + (725+145*Npart)*(number_-1) + 1; 
	f.seekg((725+6+146*Npart)*(number_-1) + 1);   

// format 0 reading		
    	  for(i = 0; i < 11; i++){ 
		    f >> str;
		  }
       	  for(i = 0; i < 2; i++){	
		    f >> ids[i] >> E[i] >> px[i] >> py[i] >> pz[i];
          }	
		  f >> str;	
          for (i = 2; i < Npart; i++){			
		    f >> ids[i] >> E[i] >> px[i] >> py[i] >> pz[i];
		   }   
          f >> str;
          

// set particles
	  particles.clear();
            for(i = 0; i < E.size(); i++){
		pa.Reset({E[i],px[i],py[i],pz[i]},c._mass(ids[i]),ids[i],c._dspin(ids[i]),0,0);	
//		pa.Print();
		particles.push_back(pa);	
	    }				
	  	 
         f.close();

     }
   
 }else{
       std::cout << "There are only " << Nev <<  " events in the file! Not enough events to get " << number_ << "'s event" << "\n";
 }	
	   
       return;				
 
};
